<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="Apache MPM 公共指令 － Apache 2.2 中文手册 [金步国作品集]">
<title>Apache MPM 公共指令 － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2007年4月5日</div>
<div id="page-content"><div id="preamble"><h1>Apache MPM 公共指令</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>收集了被多个多路处理模块(MPM)实现的公共指令</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>MPM</td></tr>
</table>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="AcceptMutex" id="AcceptMutex">AcceptMutex</a> <a name="acceptmutex" id="acceptmutex">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>Apache用于串行化多个子进程在(多个)网络套接字(socket)上接受请求的方法</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>AcceptMutex Default|<var>method</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>AcceptMutex Default</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">AcceptMutex</code>指令用于设置串行化多个子进程在(多个)网络套接字上接受请求的方法。在2.0版本以前，只能在编译时设定此方法。应当在这里使用的最佳方法取决于不同的硬件体系结构和操作系统。欲知详情，请参见<a href="../misc/perf-tuning.html">性能调节</a>文档。</p>

    <p>如果设置为<code>Default</code> ，那么将会使用编译时自动选择的默认值。其他可用的方法在下面列出。注意，并不是所有的方法在所有的平台上都是可用的，如果指定了一个不可用的方法，将会在错误日志中记录下这个不可用的方法。</p>

    <dl>
      <dt><code>flock</code></dt>
      <dd>这种方法调用系统函数<code>flock(2)</code>来锁定一个加锁文件(其位置取决于<code class="directive"><a href="#lockfile">LockFile</a></code>指令)。</dd>

      <dt><code>fcntl</code></dt>
      <dd>这种方法调用系统函数<code>fcntl(2)</code>来锁定一个加锁文件(其位置取决于<code class="directive"><a href="#lockfile">LockFile</a></code>指令)。</dd>

      <dt><code>posixsem</code></dt>
      <dd>(2.0及更新版本)这种方法使用了POSIX信号灯。如果一个运行中的线程占有了互斥segfault ，则信号灯的所有者将不会被恢复，从而导致服务器的挂起和失去响应。</dd>

      <dt><code>pthread</code></dt>
      <dd>(1.3及更新版本)这种方法使用了POSIX互斥，按理应该可以用于所有完整实现了POSIX线程规范的体系中，但是似乎只能用在Solaris2.5及更新版本中，甚至只能在某种配置下才正常运作。如果遇到这种情况，则应该提防服务器的挂起和失去响应。只提供静态内容的服务器可能不受影响。译者注：此选项不能用于Linux。</dd>

      <dt><code>sysvsem</code></dt>
      <dd>(1.3及更新版本)这种方案使用SysV风格的信号灯以实现互斥。不幸的是，SysV风格的信号灯有一些副作用，其一是，Apache有可能不能在结束以前释放这种信号灯(见<code>ipcs()</code>的man page)，另外，这种信号灯API给与网络服务器有相同uid的CGI提供了拒绝服务攻击的机会(所有CGI，除非用了类似<code class="program"><a href="../programs/suexec.html">suexec</a></code>或<code>cgiwrapper</code>)。鉴于此，在多数体系中都不用这种方法，除了IRIX(因为加锁文件的方法在IRIX中代价太高)。</dd>
    </dl>

    <p>如果你想知道编译时自动选择的默认值，你可以将<code class="directive"><a href="../mod/core.html#loglevel">LogLevel</a></code>设为<code>debug</code> ，这样默认的<code class="directive">AcceptMutex</code>就会记录到<code class="directive"><a href="../mod/core.html#errorlog">ErrorLog</a></code>中。</p>

  <div class="warning"><h3>警告</h3>
     <p>在大多数系统上，使用<code>pthread</code>时，如果一个子进程在持有<code>AcceptCntl</code>互斥信号时异常中止，服务器将会挂起和失去响应，此时必须手动重启服务器才能解决问题。但Solaris是一个例外，因为它提供了一个机制(Apache利用了该机制)，允许在一个持有互斥信号的子进程异常中止后恢复互斥信号。</p>
     <p>如果你的操作系统实现了<code>pthread_mutexattr_setrobust_np()</code>函数，基本上就能安全的使用<code>pthread</code>选项。译者注：Solaris实现了此函数，Linux却没有实现。</p>
  </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="CoreDumpDirectory" id="CoreDumpDirectory">CoreDumpDirectory</a> <a name="coredumpdirectory" id="coredumpdirectory">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>Apache使用的内核转储目录</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>CoreDumpDirectory <var>directory</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>这个指令用于控制Apache使用的内核转储目录。默认位于<code class="directive"><a href="../mod/core.html#serverroot">ServerRoot</a></code>下，因为这个目录通常对于运行服务器的用户是不可写的，内核转储一般也就不会写入内容。如果你在调试中需要内核转储，你可以用这个指令来指定另外一个目录。</p>

    <div class="note"><h3>Linux上的内核转储</h3>
      <p>如果Apache以root身份启动并切换至其他用户，即使指定的转储目录对进程是可写的，Linux内核也将<em>禁止</em>Apache进行内核转储。但是Apache2.0.46及以后的版本在你明确指定<code class="directive">CoreDumpDirectory</code>的情况下，能够在Linux2.4以上的版本中强制实现内核转储。</p>
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="EnableExceptionHook" id="EnableExceptionHook">EnableExceptionHook</a> <a name="enableexceptionhook" id="enableexceptionhook">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>在子进程崩溃以后启用一个钩子来运行异常处理程序</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>EnableExceptionHook On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>EnableExceptionHook Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.0.49 及以后的版本中可用</td></tr>
</table>
    <p>因为安全原因，这个指令仅在编译时使用了 <code>--enable-exception-hook</code> 选项的情况下才可用。它会在一个子进程崩溃以后启用一个钩子(hook)来运行一个外部模块以做些后继处理。</p>

    <p>目前有两个模块(<code>mod_whatkilledus</code>和<code>mod_backtrace</code>)可以被钩子使用。请参见Jeff Trawick的<a href="https://www.apache.org/~trawick/exception_hook.html">EnableExceptionHook site</a>以获得更多信息。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="GracefulShutdownTimeout" id="GracefulShutdownTimeout">GracefulShutdownTimeout</a> <a name="gracefulshutdowntimeout" id="gracefulshutdowntimeout">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>指定优雅停止服务器的超时秒数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>GracefulShutDownTimeout <var>seconds</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>GracefulShutDownTimeout 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code>, <code class="module"><a href="../mod/event.html">event</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.2 及以后的版本中可用</td></tr>
</table>
    <p><code class="directive">GracefulShutdownTimeout</code>设置服务器在收到"优雅停止"信号后最多允许使用多少秒来处理尚未完成的连接，超时后服务器将强行退出。</p>

    <p>设为"0"表示永不超时，也就是服务器必须在处理完所有尚未完成的请求之后才能退出。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="Group" id="Group">Group</a> <a name="group" id="group">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>对请求提供服务的Apache子进程运行时的用户组</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>Group <var>unix-group</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>Group #-1</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>Apache2.0以后只对全局配置有效</td></tr>
</table>
    <p><code class="directive">Group</code>指令指定了用于对客户端请求提供服务的Apache子进程运行时的用户组。为了使用这个指令，Apache必须以<code>root</code>初始化启动，否则在切换用户组时会失败，并继续以初始化启动时的用户组运行。<var>Unix-group</var>可以是下列之一：</p>

    <dl>
      <dt>用户组的名称</dt>
      <dd>通过名称引用组。</dd>

      <dt>"<code>#</code>"号后跟一个组编号(GID)</dt>
      <dd>通过编号引用组。</dd>
    </dl>

    <div class="example"><h3>示例</h3><p><code>
      Group www-group
    </code></p></div>

    <p>建议你专门为Apache服务器新建一个用户组。一些管理员使用<code>nobody</code>用户，但是这并非总是可用或是合适的。</p>

    <div class="warning"><h3>安全</h3>
      <p>不要将<code class="directive">Group</code>(或<code class="directive"><a href="#user">User</a></code>)设置成<code>root</code> ，除非你明确知道自己在做什么，并且明白其风险所在。</p>
    </div>

    <p>特别提示：在<code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>段中使用该指令已经不再被支持了。你可以使用<code class="program"><a href="../programs/suexec.html">suexec</a></code>的<code class="directive"><a href="../mod/mod_suexec.html#suexecusergroup">SuexecUserGroup</a></code>指令来达到这个目的。</p>

    <div class="note"><h3>注意</h3>
      <p>虽然<code class="directive">Group</code>指令也存在于<code class="module"><a href="../mod/beos.html">beos</a></code>和<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>MPM中，但是事实上没用任何用处，只不过是个摆饰罢了。</p>
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="Listen" id="Listen">Listen</a> <a name="listen" id="listen">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>服务器监听的IP地址和端口</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>Listen [<var>IP-address</var>:]<var>portnumber</var> [<var>protocol</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code>, <code class="module"><a href="../mod/event.html">event</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>Apache2.0以后必须设置该指令，<var>protocol</var>参数仅在2.1.5及以后版本中可用</td></tr>
</table>
    <p><code class="directive">Listen</code>指令指示Apache只在指定的IP地址和端口上监听；默认情况下Apache会在所有IP地址上监听。<code class="directive">Listen</code>是一个必须设置的指令。如果在配置文件中找不到这个指令，服务器将无法启动。这和先前的版本不一样。</p>

    <p><code class="directive">Listen</code>指令指定服务器在那个端口或地址和端口的组合上监听接入请求。如果只指定一个端口，服务器将在所有地址上监听该端口。如果指定了地址和端口的组合，服务器将在指定地址的指定端口上监听。</p>

    <p>使用多个<code class="directive">Listen</code>指令可以指定多个不同的监听端口和/或地址端口组合。服务器将会对列出的所有端口和地址端口组合上的请求作出应答。</p>

    <p>例如，想要服务器接受80和8000端口上的请求，可以这样设置：</p>

    <div class="example"><p><code>
      Listen 80<br />
      Listen 8000
    </code></p></div>

    <p>为了让服务器在两个确定的地址端口组合上接受请求，可以这样设置：</p>

    <div class="example"><p><code>
      Listen 192.170.2.1:80<br />
      Listen 192.170.2.5:8000
    </code></p></div>

    <p>IPv6地址必须像下面的例子一样，用方括号括起来：</p>

    <div class="example"><p><code>
      Listen [2001:db8::a00:20ff:fea7:ccea]:80
    </code></p></div>

    <p>可选的<var>protocol</var>参数在大多数情况下并不需要。若未指定该参数，则将为443端口使用默认的<code>https</code>协议，为其它端口使用<code>http</code>协议。在这里指定协议是为了确定使用哪个模块来处理请求，以及根据<code class="directive"><a href="../mod/core.html#acceptfilter">AcceptFilter</a></code>指令根据不同的协议有针对性的进行优化。</p>

    <p>仅在使用非标准端口时才需要指定<var>protocol</var>参数。比如在8443端口运行<code>https</code>协议：</p>

    <div class="example"><p><code>
      Listen 192.170.2.1:8443 https
    </code></p></div>

    <div class="note"><h3>错误条件</h3>
      多个<code class="directive">Listen</code>指令指定了同一个地址和端口的组合后，会导致"<code>Address already in use</code>"错误。
    </div>


<h3>参见</h3>
<ul>
<li><a href="../misc/dns-caveats.html">DNS问题</a></li>
<li><a href="../bind.html">地址和端口绑定</a></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ListenBackLog" id="ListenBackLog">ListenBackLog</a> <a name="listenbacklog" id="listenbacklog">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>半链接(pending connection)队列的最大长度</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ListenBacklog <var>backlog</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>ListenBacklog 511</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>半链接(pending connection)队列的最大长度。一般不需要调整此项参数，然而在一些系统上，必须增大此值以抵御TCP SYN 洪水攻击。参见操作系统的<code>listen(2)</code>系统调用的后备参数。</p>

    <p>操作系统常常将此值限制为一个较小的数字，具体根据操作系统的不同而不同。需要注意的是，许多操作系统并不是正好使用后备数值，而是取决于设置的值(通常大于后备值)。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="LockFile" id="LockFile">LockFile</a> <a name="lockfile" id="lockfile">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>接受串行锁文件的位置</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>LockFile <var>filename</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>LockFile logs/accept.lock</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">LockFile</code>指令设置当<code class="directive"><a href="#acceptmutex">AcceptMutex</a></code>指令的值是<code>fcntl</code>或<code>flock</code>的时候，Apache使用的锁文件的位置。该指令通常保持它的默认值。改变默认值的主要原因是<code>logs</code>目录位于一个NFS文件系统上，因为锁<strong>文件必须位于本地磁盘上</strong>。主服务器进程的PID会自动添加到文件名后面。</p>

    <div class="warning"><h3>安全</h3>
      <p>最好<em>不要</em>将此文件放在任何人都可以具有写权限的目录(比如<code>/var/tmp</code>)中，因为别人可以通过建立一个与服务器企图建立的锁文件同名的文件，来阻止服务器启动，从而造成一个拒绝服务攻击。</p>
    </div>

<h3>参见</h3>
<ul>
<li><code class="directive"><a href="#acceptmutex">AcceptMutex</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MaxClients" id="MaxClients">MaxClients</a> <a name="maxclients" id="maxclients">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>允许同时伺服的最大接入请求数量</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MaxClients <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">MaxClients</code>指令设置了允许同时伺服的最大接入请求数量。任何超过<code class="directive">MaxClients</code>限制的请求都将进入等候队列，直到达到<code class="directive"><a href="#listenbacklog">ListenBacklog</a></code>指令限制的最大值为止。一旦一个链接被释放，队列中的请求将得到服务。</p>

    <p>对于非线程型的MPM(也就是<code class="module"><a href="../mod/prefork.html">prefork</a></code>)，<code class="directive">MaxClients</code>表示可以用于伺服客户端请求的最大子进程数量，默认值是<code>256</code>。要增大这个值，你必须同时增大<code class="directive"><a href="#serverlimit">ServerLimit</a></code> 。</p>

    <p>对于线程型或者混合型的MPM(也就是<code class="module"><a href="../mod/beos.html">beos</a></code>或<code class="module"><a href="../mod/worker.html">worker</a></code>)，<code class="directive">MaxClients</code>表示可以用于伺服客户端请求的最大线程数量。线程型的<code class="module"><a href="../mod/beos.html">beos</a></code>的默认值是<code>50</code>。对于混合型的MPM默认值是<code>16</code>(<code class="directive"><a href="#serverlimit">ServerLimit</a></code>)乘以<code>25</code>(<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>)的结果。因此要将<code class="directive">MaxClients</code>增加到超过16个进程才能提供的时候，你必须同时增加<code class="directive"><a href="#serverlimit">ServerLimit</a></code>的值。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MaxMemFree" id="MaxMemFree">MaxMemFree</a> <a name="maxmemfree" id="maxmemfree">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>主内存分配程序在未调用<code>free()</code>的情况下允许持有的最大自由内存数量(KB)</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MaxMemFree <var>KBytes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>MaxMemFree 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code></td></tr>
</table>
    <p><code class="directive">MaxMemFree</code>指令用于设置主内存分配程序在未调用<code>free()</code>的情况下允许持有的最大自由内存数量(KB)。若未设置或设置为"0"，将表示无限制。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MaxRequestsPerChild" id="MaxRequestsPerChild">MaxRequestsPerChild</a> <a name="maxrequestsperchild" id="maxrequestsperchild">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>每个子进程在其生存期内允许伺服的最大请求数量</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MaxRequestsPerChild <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>MaxRequestsPerChild 10000</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">MaxRequestsPerChild</code>指令设置每个子进程在其生存期内允许伺服的最大请求数量。到达<code class="directive">MaxRequestsPerChild</code>的限制后，子进程将会结束。如果<code class="directive">MaxRequestsPerChild</code>为"<code>0</code>"，子进程将永远不会结束。</p>

    <div class="note"><h3>不同的默认值</h3>
      <p>在<code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>和<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>上的默认值是"<code>0</code>"。</p>
    </div>

    <p>将<code class="directive">MaxRequestsPerChild</code>设置成非零值有两个好处：</p>

    <ul>
      <li>可以防止(偶然的)内存泄漏无限进行，从而耗尽内存。</li>

      <li>给进程一个有限寿命，从而有助于当服务器负载减轻的时候减少活动进程的数量。</li>
    </ul>

    <div class="note"><h3>注意</h3>
      <p>对于<code class="directive"><a href="../mod/core.html#keepalive">KeepAlive</a></code>链接，只有第一个请求会被计数。事实上，它改变了每个子进程限制最大<em>链接</em>数量的行为。</p>
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MaxSpareThreads" id="MaxSpareThreads">MaxSpareThreads</a> <a name="maxsparethreads" id="maxsparethreads">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>最大空闲线程数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MaxSpareThreads <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>设置最大空闲线程数。不同的MPM对这个指令的处理是不一样的：</p>

    <p><code class="module"><a href="../mod/worker.html">worker</a></code>的默认值是"<code>250</code>"。这个MPM将基于整个服务器监视空闲线程数。如果服务器中总的空闲线程数太多，子进程将杀死多余的空闲线程。</p>

    <p><code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>的默认值是"<code>100</code>"。既然这个MPM只运行单独一个子进程，此MPM当然亦基于整个服务器监视空闲线程数。</p>

    <p><code class="module"><a href="../mod/beos.html">beos</a></code>和<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>的工作方式与<code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>差不多，<code class="module"><a href="../mod/beos.html">beos</a></code>的默认值是"<code>50</code>"；<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>的默认值是"<code>10</code>"。</p>

    <div class="note"><h3>限制</h3>
      <p><code class="directive">MaxSpareThreads</code>的取值范围是有限制的。Apache将按照如下限制自动修正你设置的值：</p>
      <ul>

        <li><code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>要求其小于等于<code class="directive"><a href="#minsparethreads">MinSpareThreads</a></code></li>

        <li><code class="module"><a href="../mod/worker.html">worker</a></code>要求其大于等于<code class="directive"><a href="#minsparethreads">MinSpareThreads</a></code>加上<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>的和</li>
      </ul>
    </div>

<h3>参见</h3>
<ul>
<li><code class="directive"><a href="#minsparethreads">MinSpareThreads</a></code></li>
<li><code class="directive"><a href="#startservers">StartServers</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="MinSpareThreads" id="MinSpareThreads">MinSpareThreads</a> <a name="minsparethreads" id="minsparethreads">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>最小空闲线程数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>MinSpareThreads <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>设置最小空闲线程数，用于处理可能到来的突发请求。不同的MPM对这个指令的处理是不一样的：</p>


    <p><code class="module"><a href="../mod/worker.html">worker</a></code>的默认值是"<code>75</code>"。这个MPM将基于整个服务器监视空闲线程数。如果服务器中总的空闲线程数太少，子进程将产生新的空闲线程。</p>

    <p><code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>的默认值是"<code>10</code>"。既然这个MPM只运行单独一个子进程，此MPM当然亦基于整个服务器监视空闲线程数。</p>

    <p><code class="module"><a href="../mod/beos.html">beos</a></code>和<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>的工作方式与<code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>差不多，<code class="module"><a href="../mod/beos.html">beos</a></code>的默认值是"<code>1</code>"；<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>的默认值是"<code>5</code>"。</p>

<h3>参见</h3>
<ul>
<li><code class="directive"><a href="#maxsparethreads">MaxSpareThreads</a></code></li>
<li><code class="directive"><a href="#startservers">StartServers</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="PidFile" id="PidFile">PidFile</a> <a name="pidfile" id="pidfile">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>服务器用于记录父进程(监控进程)PID的文件</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>PidFile <var>filename</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>PidFile logs/httpd.pid</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">PidFile</code>指令设置服务器用于记录父进程(监控进程)PID的文件。如果指定的不是绝对路径，那么将视为基于<code class="directive"><a href="../mod/core.html#serverroot">ServerRoot</a></code>的相对路径。</p>

    <div class="example"><h3>示例</h3><p><code>
      PidFile /var/run/apache.pid
    </code></p></div>

    <p>这个文件通常用来便于给服务器父进程发送一个信号，用于关闭或重启服务器，以重新打开<code class="directive"><a href="../mod/core.html#errorlog">ErrorLog</a></code>和<code class="directive"><a href="../mod/mod_log_config.html#transferlog">TransferLog</a></code>文件、重新读取配置文件。这些可以通过发送一个"SIGHUP"(kill -1)信号到<code class="directive">PidFile</code>记录的进程PID。</p>

    <p><code class="directive">PidFile</code>和其他日志文件一样要注意放置位置和<a href="../misc/security_tips.html#serverroot">安全</a>问题。</p>

    <div class="note"><h3>注意</h3>
      <p>从Apache2开始，推荐使用<code class="program"><a href="../programs/apachectl.html">apachectl</a></code>脚本来启动或停止服务器。</p>
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ReceiveBufferSize" id="ReceiveBufferSize">ReceiveBufferSize</a> <a name="receivebuffersize" id="receivebuffersize">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>TCP接收缓冲区大小(字节)</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ReceiveBufferSize <var>bytes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>ReceiveBufferSize 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>这个指令设置服务器的TCP接收缓冲区的大小(字节)。提高这个值会导致两个后果：高速度和高潜伏时间(100ms左右)。</p>

    <p>如果设置为"<code>0</code>"，将使用操作系统默认值。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ScoreBoardFile" id="ScoreBoardFile">ScoreBoardFile</a> <a name="scoreboardfile" id="scoreboardfile">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>存储子进程协调数据(coordination data)的文件</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ScoreBoardFile <var>file-path</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>ScoreBoardFile logs/apache_status</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>Apache使用记分板(scoreboard)在父进程和子进程之间进行通信。一些体系结构要求有一个文件来帮助通信。如果未指定这个文件，Apache会首先尝试在匿名共享内存中建立完整的记分板(scoreboard)，若失败，将继续尝试使用基于文件的共享存储器在磁盘上建立这个文件。若利用这个指令指定这个文件的位置，则Apache将总是在磁盘上建立这个文件。</p>

    <div class="example"><h3>示例</h3><p><code>
      ScoreBoardFile /var/run/apache_status
    </code></p></div>

    <p>基于文件的共享存储器对于使用直接访问记分板(scoreboard)的第三方程序是很有用的。</p>

    <p>将<code class="directive">ScoreBoardFile</code>放置在RAM disk中会对速度提升有很大帮助。但是同其他日志文件一样也要注意放置位置和<a href="../misc/security_tips.html">安全</a>问题。</p>

<h3>参见</h3>
<ul>
<li><a href="../stopping.html">停止和重启Apache</a></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="SendBufferSize" id="SendBufferSize">SendBufferSize</a> <a name="sendbuffersize" id="sendbuffersize">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>TCP发送缓冲区大小(字节)</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>SendBufferSize <var>bytes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>SendBufferSize 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>这个指令设置服务器的TCP发送缓冲区的大小(字节)。提高这个值会导致两个后果：高速度和高潜伏时间(100ms左右)。</p>

    <p>如果设置为"<code>0</code>"，将使用操作系统默认值。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ServerLimit" id="ServerLimit">ServerLimit</a> <a name="serverlimit" id="serverlimit">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>服务器允许配置的进程数上限</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ServerLimit <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>对于<code class="module"><a href="../mod/prefork.html">prefork</a></code>MPM，这个指令设置了<code class="directive"><a href="#maxclients">MaxClients</a></code>最大允许配置的数值。对于<code class="module"><a href="../mod/worker.html">worker</a></code>MPM，这个指令和<code class="directive"><a href="#threadlimit">ThreadLimit</a></code>结合使用设置了<code class="directive"><a href="#maxclients">MaxClients</a></code>最大允许配置的数值。任何在重启期间对这个指令的改变都将被忽略，但对<code class="directive"><a href="#maxclients">MaxClients</a></code>的修改却会生效。</p>

    <p>使用这个指令时要特别当心。如果将<code class="directive">ServerLimit</code>设置成一个高出实际需要许多的值，将会有过多的共享内存被分配。如果将<code class="directive">ServerLimit</code>和<code class="directive"><a href="#maxclients">MaxClients</a></code>设置成超过系统的处理能力，Apache可能无法启动，或者系统将变得不稳定。</p>

    <p>对于<code class="module"><a href="../mod/prefork.html">prefork</a></code>MPM，只有在你需要将<code class="directive"><a href="#maxclients">MaxClients</a></code>设置成高于默认值256的时候才需要使用这个指令。要将此指令的值保持和<code class="directive"><a href="#maxclients">MaxClients</a></code>一样。</p>

    <p>对于<code class="module"><a href="../mod/worker.html">worker</a></code>MPM，只有在你需要将<code class="directive"><a href="#maxclients">MaxClients</a></code>和<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>设置成需要超过默认值16个子进程的时候才需要使用这个指令。不要将该指令的值设置的比<code class="directive"><a href="#maxclients ">MaxClients </a></code>和<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>需要的子进程数量高。</p>

    <div class="note"><h3>注意</h3>
      <p>Apache在编译时内部有一个硬限制"<code>ServerLimit 20000</code>"(对于<code class="module"><a href="../mod/prefork.html">prefork</a></code>MPM为"<code>ServerLimit 200000</code>")。你不能超越这个限制。</p>
    </div>

<h3>参见</h3>
<ul>
<li><a href="../stopping.html">停止和重启Apache</a></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="StartServers" id="StartServers">StartServers</a> <a name="startservers" id="startservers">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>服务器启动时建立的子进程数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>StartServers <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>, <code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p><code class="directive">StartServers</code>指令设置了服务器启动时建立的子进程数量。因为子进程数量动态的取决于负载的轻重，所有一般没有必要调整这个参数。</p>

    <p>不同的MPM默认值也不一样。对于<code class="module"><a href="../mod/worker.html">worker</a></code>默认值是"<code>3</code>"。对于<code class="module"><a href="../mod/prefork.html">prefork</a></code>默认值是"<code>5</code>"，<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>是"<code>2</code>"。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="StartThreads" id="StartThreads">StartThreads</a> <a name="startthreads" id="startthreads">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>服务器启动时建立的线程数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>StartThreads <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/beos.html">beos</a></code>, <code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code></td></tr>
</table>
    <p>设置了服务器启动时建立的线程数量。因为线程数量动态的取决于负载的轻重，所有一般没有必要调整这个参数。</p>

    <p>对于<code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code> ，默认值是"<code>50</code>"，由于只有一个进程，因此所有的线程都将用于伺服请求。</p>

    <p>对于<code class="module"><a href="../mod/beos.html">beos</a></code> ，默认值是"<code>10</code>"，同样也是所有的线程都将用于伺服请求。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ThreadLimit" id="ThreadLimit">ThreadLimit</a> <a name="threadlimit" id="threadlimit">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>每个子进程可配置的线程数上限</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ThreadLimit <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅用于2.0.41及以后版本的<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code></td></tr>
</table>
    <p>这个指令设置了每个子进程可配置的线程数<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>上限。任何在重启期间对这个指令的改变都将被忽略，但对<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>的修改却会生效。</p>

    <p>使用这个指令时要特别当心。如果将<code class="directive">ThreadLimit</code>设置成一个高出<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>实际需要很多的值，将会有过多的共享内存被分配。如果将<code class="directive">ThreadLimit</code>和<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>设置成超过系统的处理能力，Apache可能无法启动，或者系统将变得不稳定。该指令的值应当和<code class="directive"><a href="#threadsperchild">ThreadsPerChild</a></code>可能达到的最大值保持一致。</p>

    <p>对于<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>，<code class="directive">ThreadLimit</code>的默认值是<code>1920</code>；对于其他MPM这个值是<code>64</code>。</p>

    <div class="note"><h3>注意</h3>
      <p>Apache在编译时内部有一个硬性的限制"<code>ThreadLimit 20000</code>"(对于<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>是"<code>ThreadLimit 15000</code>")，你不能超越这个限制。</p>
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ThreadsPerChild" id="ThreadsPerChild">ThreadsPerChild</a> <a name="threadsperchild" id="threadsperchild">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>每个子进程建立的线程数</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ThreadsPerChild <var>number</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>参见下面的说明</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
</table>
    <p>这个指令设置了每个子进程建立的线程数。子进程在启动时建立这些线程后就不再建立新的线程了。如果使用一个类似于<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>只有一个子进程的MPM，这个数值要足够大，以便可以处理可能的请求高峰。如果使用一个类似于<code class="module"><a href="../mod/worker.html">worker</a></code>有多个子进程的MPM，每个子进程所拥有的<em>所有</em>线程的总数要足够大，以便可以处理可能的请求高峰。</p>

    <p>对于<code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>，<code class="directive">ThreadsPerChild</code>的默认值是<code>64</code>；对于其他MPM是<code>25</code>。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ThreadStackSize" id="ThreadStackSize">ThreadStackSize</a> <a name="threadstacksize" id="threadstacksize">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>处理客户端连接的线程使用的栈尺寸(字节)</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ThreadStackSize <var>size</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>NetWare上为65536；其它平台上等于操作系统默认值</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/mpm_netware.html">mpm_netware</a></code>, <code class="module"><a href="../mod/mpm_winnt.html">mpm_winnt</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.1 及以后的版本中可用</td></tr>
</table>
    <p><code class="directive">ThreadStackSize</code>指令设置了处理客户端连接(包括调用模块以协助处理)的线程允许使用的最大栈尺寸(字节)。在大多数情况下，操作系统默认的栈尺寸很合理，但是在某些情况下，需要调整这个值：</p>

    <ul>
      <li>在默认栈尺寸较小的平台上(比如HP-UX)，Apache可能会在使用一些需要较大栈尺寸的第三方模块时崩溃。这样的问题可以通过将<code class="directive">ThreadStackSize</code>设置为一个较大的值来解决。这种调整应当仅仅在第三方模块提供者明确要求的情况下才需要，或者是您通过诊断确定是由于栈空间太小而导致崩溃。</li>

      <li>在某些平台上，如果默认的栈空间大于服务器运行所需空间，那么将<code class="directive">ThreadStackSize</code>值降低到小于操作系统默认值可以让每个进程中允许生成的最大线程数量增加。这种类型的调整应该仅在测试环境中使用，并且对所有服务器进程进行充分的测试，因为处理某些罕见的请求需要较大的栈空间。一个很小的服务器配置变化就有可能使得当前的<code class="directive">ThreadStackSize</code>设置变得不合适。</li>
    </ul>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="User" id="User">User</a> <a name="user" id="user">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>实际服务于请求的子进程运行时的用户</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>User <var>unix-userid</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>User #-1</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>MPM</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td><code class="module"><a href="../mod/prefork.html">prefork</a></code>, <code class="module"><a href="../mod/worker.html">worker</a></code></td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>2.0版本起仅在全局服务器配置中可用</td></tr>
</table>
    <p><code class="directive">User</code>指令用于设置实际提供服务的子进程的用户。为了使用这个指令，服务器必须以<code>root</code>身份启动和初始化。如果你以非<code>root</code>身份启动服务器，子进程将不能够切换至非特权用户，并继续以启动服务器的原始用户身份运行。如果确实以<code>root</code>用户启动了服务器，那么父进程将仍然以<code>root</code>身份运行。<var>Unix-userid</var>是下列值之一：</p>

    <dl>
      <dt>一个用户名</dt>
      <dd>通过用户名引用用户</dd>

      <dt>"#"号后面跟一个用户编号</dt>
      <dd>通过用户编号引用用户</dd>
    </dl>

    <p>用于运行子进程的用户必须是一个没有特权的用户，这样才能保证子进程无权访问那些不想为外界所知的文件，同样的，该用户亦需没有执行那些不应当被外界执行的程序的权限。强烈推荐你专门为Apache子进程建立一个单独的用户和组。一些管理员使用<code>nobody</code>用户，但是这并不能总是符合要求，因为可能有其他程序也在使用这个用户。</p>

    <div class="warning"><h3>安全</h3>
      <p>不要将<code class="directive">User</code>(或<code class="directive"><a href="#group">Group</a></code>)设置成<code>root</code> ，除非你明确知道自己在做什么，并且明白其风险所在。</p>
    </div>

    <p>特别提示：在<code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>段中使用该指令已经不再被支持了。你可以使用<code class="program"><a href="../programs/suexec.html">suexec</a></code>的<code class="directive"><a href="../mod/mod_suexec.html#suexecusergroup">SuexecUserGroup</a></code>指令来达到这个目的。</p>

    <div class="note"><h3>注意</h3>
      <p>虽然<code class="directive">User</code>指令也存在于<code class="module"><a href="../mod/beos.html">beos</a></code>和<code class="module"><a href="../mod/mpmt_os2.html">mpmt_os2</a></code>MPM中，但是事实上没用任何用处，只不过是个摆饰罢了。</p>
    </div>

</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
